/**
 * Projet Système de particules
 *
 * chaine.h
 *
 * Définition du type chaine.
 *
 */

#ifndef _H_CHAINE
#define _H_CHAINE

/* Définition de la structure type Chaine */
typedef struct {
	Particule* e1; /* Première extrémité de la chaine */
	Particule* e2; /* Seconde extrémité de la chaîne */
	double longueur; /* Longueur (maximale) de la chaine */
	} Chaine;


/** Fonction d'ajout d'une chaine
 * Arguments:
 *	p1: Première particule
 *	p2: Seconde particule
 *	l: Longueur de la chaine
 * Retourne: La chaine qui vient d'être créée
 */
Chaine* creer_chaine(Particule* p1, Particule* p2, double l);

/** Procédure de résolution de contrainte de type "chaine"
 * Argument: La chaine dont on veut résoudre la contrainte
 */
void resoudre_contrainte_chaine(Chaine* chaine);

/** Procédure détruisant la chaine
 * Argument: chaine: Chaine à détruire
 */
void detruire_chaine(Chaine** chaine);

/** Procédure utilisée pour convertir l'appel à detruire_chainee dans
 * l'itérateur
 * Argument: chaine: La chaine à détruire
 */
void detruire_chaine_it(Chaine* chaine);

#endif
