/** Définition de la contrainte espace
 */

#ifndef _H_espace
#define _H_espace
/* Définition de la structure Espace */
typedef struct {
	Particule* e1; /* Première extrémité de l'espace */
	Particule* e2; /* Seconde extrémité de l'espace */
	double longueur; /* Longueur (minimale) de l'espace */
	} Espace;

/** Fonction d'ajout d'un espace
 * Arguments:
 *	p1: Première particule
 *	p2: Seconde particule
 *	l: Longueur de l'espace
 * Retourne: La espace qui vient d'être créée
 */
Espace* creer_espace(Particule* p1, Particule* p2, double l);

/** Procédure de résolution de contrainte de type "espace"
 * Argument: L'espace dont on veut résoudre la contrainte
 */
void resoudre_contrainte_espace(Espace* espace);

/** Procédure détruisant l'espace
 * Argument: espace: Espace à détruire
 */
void detruire_espace(Espace** espace);

/** Procédure utilisée pour convertir l'appel à detruire_espace dans
 * l'itérateur
 * Argument: espace: L'espace à détruire
 */
void detruire_espace_it(Espace* espace);

#endif
