/*
 * Projet Système de particules
 *
 * geometrie.h
 *
 *  Fonctions et types géométriques utiles.
 *
 *      --- A compléter si besoin ---
 *
 */

#ifndef __GEOMETRIE_H__
#define __GEOMETRIE_H__

struct _Coordonnees {
  double x;
  double y;
};

typedef struct _Coordonnees Point;

/** Structure de donnée vecteur */
typedef struct Vect {
	double norme_x; /* Norme en abscisse */
	double norme_y; /* Norme en ordonnée */
} Vecteur;

/** Fonction créant un point en coordonnées cartésiennes
 * Arguments:
 * 	x: Abscisse du point
 * 	y: Ordonnée du point
 * Retourne: Un pointeur sur le point créé
 */
Point* creer_point (double x, double y);

/** Fonction calculant la distance entre deux points
 * Arguments:
 * 	*p1: Premier point
 * 	*p2: Deuxieme point
 * Retourne: La distance entre p1 et p2
 */
double distance (Point* p1, Point* p2);

/** Fonction de création d'un vecteur
 * Arguments:
 * 	nx: Norme en x
 * 	ny: Norme en y
 * Retourne: Un pointeur sur un vecteur
 */
Vecteur* creer_vecteur (double nx, double ny);

/** Procédure détruisant un vecteur
 * Argument: vect: Le vecteur à détruire
*/
void detruire_vecteur(Vecteur** vecteur);

/** Procédure utilisée lors de l'appel à detruire_vecteur dans l'itérateur
 * Argument: vect: Vecteur à détruire
*/
void detruire_vecteur_it(Vecteur* vect);

/** Fonction retournant la norme d'un vecteur
 * Argument: Un vecteur
 * Retourne: La norme du vecteur
 */
double norme(Vecteur* vect);

#endif
