/* Implémentation du module Liste Chaînée Polymorphe */

#include <stdio.h>
#include <malloc.h>
#include <stdlib.h>
#include "list.h"

/* la structure node */
struct node {
    void        *label;
    struct node *queue;
};


T_LIST nil() {
  return NULL;
}

int cons(void *val, T_LIST *l) {

  T_LIST res = (T_LIST) malloc(sizeof(struct node));

  if(res == NULL) {
    return ALLOC_ERROR;
  }
  else {
    res -> label = val;
    res -> queue = *l;
    *l = res;
    return NO_ERROR;
  }
  
}

int is_empty(T_LIST l) {
  return (l==NULL);
}

void* head(T_LIST l, int* ret) {

  if(is_empty(l)) {
    *ret = USAGE_PARAM;
    return NULL;
  }
  else {
    *ret = NO_ERROR;
    return l -> label;
  }
  
}

T_LIST tail(T_LIST l, int *ret) {

  if(is_empty(l)) {
    *ret = USAGE_PARAM;
    return NULL;
  }
  else {
    *ret = NO_ERROR;
    return l -> queue;
  }
  
}

void *member(void *val, T_LIST l, int (*equal)()) {

  while((l != NULL) && !(*equal)(val, l -> label) ){
    l = l -> queue;
  }
  
  if(l == NULL) {
    return NULL;
  }
  else {
    return l -> label;
  }

}

int insert_in_sorted_list(T_LIST *ancre, void *val, 
                          int doublon, int (*cmp)()) {

  T_LIST aux, cour, precedent;
  int  ret= NO_ERROR;

  if( cmp == NULL || ancre == NULL || val == NULL ) {
   ret = USAGE_PARAM;
  } else if (is_empty(*ancre)) {
    /* liste vide */
    ret = cons(val, ancre);
  } else {

    cour = *ancre;

    if( cmp(val, cour -> label) <= 0 ) {
      /* insertion en tête */
      
      if( cmp(val, cour -> label) == 0 && !doublon ) {
        ret = NO_ERROR;
      } else {
        aux = nil();
        ret = cons(val, &aux);
        if ( ret == NO_ERROR ) {
          aux -> queue = cour;
          *ancre = aux;
        }
      }
      
    } else {
      /* insertion ailleurs */
      
      precedent = cour;
      cour = cour -> queue;
      while ( (cour != NULL) && cmp(cour -> label, val) < 0 ) {
        precedent= cour;
        cour= cour -> queue;
      }

      if( (cour != NULL) && (cmp(val, cour -> label) == 0) && !doublon ) {
        ret = NO_ERROR;
      } else {
        aux = nil();
        ret= cons(val, &aux);
        if ( ret == NO_ERROR ) {
          precedent -> queue = aux;
          aux -> queue = cour;
        }
      }
    }
  }
  
  return ret;
  
}
  
void do_list(void (*p)(), T_LIST l) {

  if( is_empty(l) ) {
    return;
  }
  else {
    (*p)(l -> label);
    do_list(p, l -> queue);
  }
}
